<script lang="ts">
  import { Button, Form, Input, InputGroup, InputGroupText } from '@sveltestrap/sveltestrap';
  import BlueteamSelect from '../Utils/BlueteamSelect.svelte';
  import type { Team } from '@models/Team';
  import { Gql } from '@db';
  import { EventRole } from '@auth/models';
  import { eventId, keycloak } from '@stores';
  import Fa from 'svelte-fa';
  import { faArrowRightFromBracket, faTrophy } from '@fortawesome/free-solid-svg-icons';
  import { onMount } from 'svelte';
  import { BonusPointCategoriesQuery } from '@models/BonusPoints';
  import { getNotificationsContext } from 'svelte-notifications';

  const { addNotification } = getNotificationsContext();

  let selectedTeam: Team | null = null;
  let points: number | null;
  let reason: string;
  let category: string = 'bonus';
  let categories: string[] = [];
  $: queryRole = $keycloak?.getFirstRole([EventRole.SuperAdmin, EventRole.EventAdmin]);

  onMount(async () => {
    categories = (
      await Gql.query<{ scoring_bonus_points: { category: string }[] }>(BonusPointCategoriesQuery, { queryRole })
    ).scoring_bonus_points.map((data) => data.category);
  });

  function awardPoints(e: Event) {
    e.preventDefault();
    if (!selectedTeam) {
      addNotification({
        position: 'bottom-right',
        type: 'error',
        text: 'Please select a team to award points to.',
        removeAfter: 5000,
      });
      return;
    }
    const q = `mutation AddBonusPoints($input: scoring_bonus_points_insert_input!) {
      insert_scoring_bonus_points_one(object: $input) {
        id
        event_id
        team_id
        points
        reason
        time
      }
    }`;
    Gql.query(q, {
      role: EventRole.EventAdmin,
      variables: {
        input: {
          event_id: $eventId,
          points,
          category,
          reason,
          team_id: selectedTeam.id,
        },
      },
    });

    // deselect team but leave other info populated in-case awarding multiple teams
    selectedTeam = null;
  }
</script>

<Form on:submit={awardPoints}>
  <InputGroup class="pb-3">
    <InputGroupText>Category:</InputGroupText>
    {#if categories}
      {#each categories as cat}
        <Button
          color="light"
          on:click={(e) => {
            e.preventDefault();
            category = cat;
          }}
        >
          {cat}
          <Fa icon={faArrowRightFromBracket} />
        </Button>
      {/each}
    {/if}
    <Input bind:value={category} placeholder="inject" required />
  </InputGroup>
  <InputGroup class="pb-3">
    <InputGroupText>Reason:</InputGroupText>
    <Input bind:value={reason} type="text" name="reason" placeholder="Did the thing!" />
  </InputGroup>
  <InputGroup class="pb-3">
    <BlueteamSelect bind:selectedTeam />
    <InputGroupText>Points:</InputGroupText>
    <Input bind:value={points} type="number" label="Points" placeholder="50" required />
    <Button class="">
      <Fa icon={faTrophy} /> Award/Dock Points
    </Button>
  </InputGroup>
</Form>
